
ISIS - Bug #1301

fx - does not handle multi-band, band-dependent images correctly. (was "problem with the ema

function with LROC WAC data")

2012-11-27 10:47 AM - Tammy Becker

Status: Closed   

Priority: Normal   

Assignee: Ian Humphrey   

Category: Applications   

Target version: FY17 Backlog   

Impact: fx will calculate camera-related

information correctly for each band with

band-dependent images.

Software Version:  

Description

External Post:

https://isis.astrogeology.usgs.gov/IsisSupport/index.php/topic,3589.0.html

Using a LROC WAC image, I ran the command on a 5 band lvl 1 cube with spice information.

f1={imagename}.vis.even.cub to= {imagename}.vis.even.emi.cub equation= ema(f1)

The program ran and exited cleanly.

However, the resulting 5 band cube returned the same results for each band, even though the value should have been much

different.

It appears that the photometric angles are NOT calculated separately for each band.

-Aaron

IsisVersion =  "3.4.1.4648 stable | 2012-08-17"

ProgramVersion    = 2012-02-09

History

#1 - 2012-11-27 10:49 AM - Tammy Becker

Jeff Anderson supplied a work around (Nov13, 2012):

HI Aaron,

Your analysis is correct.  For now you will need to run fx as follows:

fx f1=(imagename).vis.even.cub+1 to=(imagename).vis.emi_b1.cub equation=ema(f1)

fx f1=(imagename).vis.even.cub+2 to=(imagename).vis.emi_b2.cub equation=ema(f1)

fx f1=(imagename).vis.even.cub+3 to=(imagename).vis.emi_b3.cub equation=ema(f1)

fx f1=(imagename).vis.even.cub+4 to=(imagename).vis.emi_b4.cub equation=ema(f1)

fx f1=(imagename).vis.even.cub+5 to=(imagename).vis.emi_b5.cub equation=ema(f1)

I believe that should do the trick.   We will put in a new mantis ticket to resolve this issue in the future.

Jeff
#2 - 2013-03-28 11:16 AM - Tammy Becker

- Target version changed from 150 to 3.4.4 (2013-06-25 Jun)

#3 - 2013-03-29 06:52 PM - Tammy Becker

- Target version changed from 3.4.4 (2013-06-25 Jun) to 150

#5 - 2013-08-15 10:42 AM - Anonymous

- Target version deleted (150)

#6 - 2014-05-16 03:48 PM - Stuart Sides

- Target version set to 3.4.7 (2014-08-27 Aug)

#7 - 2014-09-08 11:11 AM - Stuart Sides

- Target version changed from 3.4.7 (2014-08-27 Aug) to 159

#8 - 2014-11-13 04:19 PM - Stuart Sides

This problem will occur with any band dependent camera model (VimsCamera, LroWideAngleCamera, MarciCamera, MvicFrameCamera,

NewHorizonsLeisaCamera, ThemisIrCamera, and ThemisVisCamera). The FX program needs ask the camera model if it is BandDependent or not,

and then recalculate camera parameters if then band changes (only when the model is band dependent). It should not recalculate them if the model is

band independent. It is a costly process.

#9 - 2014-11-13 04:19 PM - Stuart Sides

- Target version changed from 159 to 3.4.9 (FY15 R2 2015-03-26 Mar)

#10 - 2014-11-19 09:39 AM - Stuart Sides

- Assignee set to Moses Milazzo

#13 - 2014-11-20 09:58 AM - Moses Milazzo

Should accounting for band-dependency be in fx or should it be in one of the Process classes?

#14 - 2014-12-03 09:46 AM - Stuart Sides

- Status changed from Acknowledged to Assigned

#16 - 2015-02-06 06:42 AM - Moses Milazzo

This appears to be an issue with either the CubeCalculator class, rather than with fx explicitly. 

#17 - 2015-02-06 06:43 AM - Moses Milazzo

- Status changed from Assigned to In Progress

#18 - 2015-02-06 06:54 AM - Moses Milazzo

- Subject changed from fx - problem with the ema function with LROC WAC data to fx - CubeCalculator Class does not handle multi-band,

band-dependent images correctly. (was "problem with the ema function with LROC WAC data")

#19 - 2015-02-06 11:26 AM - Moses Milazzo

- Subject changed from fx - CubeCalculator Class does not handle multi-band, band-dependent images correctly. (was "problem with the ema function

with LROC WAC data") to fx - does not handle multi-band, band-dependent images correctly. (was "problem with the ema function with LROC WAC

data")
I think I found a way to do this without modifying the CubeCalculator class directly. 

#20 - 2015-02-13 08:19 AM - Moses Milazzo

This seems to be fixed and is out to Tammy for testing.

#21 - 2015-02-19 12:08 PM - Lynn Weller

I tested the changes on a 10 band themis ir image and it looks good.

Data are under /work/users/lweller/Isis3Tests/FX/ISIS3/m1301/.  There is an incorrect production version and one for m1301.  I was lazy and just

tested equation=ema(f1), but I knew I'd see the biggest differences among bands for that angle.

#22 - 2015-02-19 12:23 PM - Moses Milazzo

Thanks, Lynn!

#23 - 2015-02-22 03:31 PM - Tammy Becker

I've tested with the emission angle on a Cassini VIMS cube of Titan.  The results between isis3production and m01301 are exactly the same for all

bands.   This might be expected for a spectral spot instrument??  we should confirm.    

I also question the emission angle value that the ema function returns at a pixel location as compared to campt and qview-emission angle value at the

same pixel location.

Test area:

/work/users/tbecker/IsisTesting/FX_Test/2015/M1301-FX-BandDependent/V1515958715_1.ir.cub

#24 - 2015-02-23 12:17 PM - Lynn Weller

I've looked at my data in a similar way as Tammy and am learning I don't know the difference between emission and local emission angle!

Someone who better understands can hopefully make heads or tails out of what I'm reporting....I'm just getting more confused the more I look.

At the center of the image, the following is reported:

FX ema(f1) output

qview pixel value         : 1.4513965  (actual fx output dn)

qview emission value      : 1.4514     (must be using the kernels/camera model)

qview local emission value: 2.74996    (same as above)

Input to FX, initialized with MOLA dem

qview emission value      : 1.4514

qview local emission value: 2.74996

campt emission value      : 1.4513964454497

campt does not report a local emission angle.  All of the above makes sense to me (I think), but I'm concerned about campt output now because I had

always assumed the illumination information returned was based on interstecting a shape model but I now realize this is not the case!

I made a copy of my image and initizlized to the ellipsoid and popped it open in qview and recorded the following:

Image initialized to ellipsoid

qview emission value      : 1.4512      (close enough to fx/dem input image values??)

qview local emission value: 1.5201       (what is this?  shouldn't this be same as emission value since there is no shape model?)

campt emission value      : 1.452117503606

Tammy's numbers are apparently wackier, so it could be an instrument issue or something more complex in her case.  The biggest issue I see with

what is being reported above is the local emission angle that is being reported by qview for the ellipsoid initialized image.  I'm running fx now using

emal(f1) to see what its results are like.

My data are here:/work/users/lweller/Isis3Tests/FX/ISIS3/m1301/

I'm going to stop testing unless otherwise requested....I don't think I'm helping by being confused.  And as far as the specifics of this post are

concerned, I get different ouput for each band of my input image, not the same value propagated as isis currently behaves.
#25 - 2015-03-12 12:25 PM - Stuart Sides

- Target version changed from 3.4.9 (FY15 R2 2015-03-26 Mar) to 3.4.10 (FY15 R3 2015-07-23 Jul)

#27 - 2016-07-12 07:56 AM - Stuart Sides

- Target version changed from 3.4.10 (FY15 R3 2015-07-23 Jul) to 3.4.13 (FY16 R3 2016-08-31 Aug)

#28 - 2016-07-12 08:47 AM - Stuart Sides

- Assignee changed from Moses Milazzo to Ian Humphrey

#29 - 2016-07-19 02:29 PM - Ian Humphrey

- Impact updated

#30 - 2016-08-18 03:59 PM - Ian Humphrey

- Status changed from In Progress to Resolved

- Impact updated

To test,

setisis /work/projects/isis/latest/m01301_ihumphrey/isis

The center camera operators (phac, inac, and emac) now correctly work for band-dependent images.

I've added a new test case to fx that tests all the camera-related operators (radius, phac, inac, emac, pha, ina, ema, phal, inal, emal, lat, lon, res).

This uses a cropped themis IR cube for its input.

I've slightly modified the xml so that the documentation discusses that the camera-related operators make calculations on a band-by-band basis.

I'll send the html to Janet for review.

#31 - 2016-08-18 05:09 PM - Ian Humphrey

- Impact updated

#32 - 2016-10-03 10:15 AM - Stuart Sides

- Target version changed from 3.4.13 (FY16 R3 2016-08-31 Aug) to FY17 Backlog

#33 - 2016-10-12 01:34 PM - Ian Humphrey

Testing Procedure (regarding LRO-WAC image):

setisis /work/projects/isis/latest/m01301_ihumphrey/isis

LRO-WAC image located at $ISISROOT/../Testing/wac.even.cub

I will be referencing "fixed 1301 fx" and "work-around fx" through this note. "Fixed 1301 fx" refers to the fx installed in $ISISROOT. "Work-around fx"

refers to running fx one band at a time.

Commands and Operators Tested

We'll be testing the ema and emac fx operators on this cropped WAC (even visible) image.
EMA Operator

Commands run with fix:

fx f1=wac.even.cub to=wac.ema.even.cub equation=ema(f1)

 

Commands run with work-around:

fx f1=wac.even.cub+1 to=wac.ema.even_b1.cub equation=ema(f1)

fx f1=wac.even.cub+2 to=wac.ema.even_b2.cub equation=ema(f1)

fx f1=wac.even.cub+3 to=wac.ema.even_b3.cub equation=ema(f1)

fx f1=wac.even.cub+4 to=wac.ema.even_b4.cub equation=ema(f1)

fx f1=wac.even.cub+5 to=wac.ema.even_b5.cub equation=ema(f1)

ls -1 wac.ema.even_b*.cub > wac_ema_bands.lis

cubeit fromlist=wac_ema_bands.lis to=wac.ema.even.cubeit.cub

 

EMAC Operator

Commands run with fix:

fx f1=wac.even.cub to=wac.emac.even.cub equation=emac(f1)

 

Commands run with work-around:

fx f1=wac.even.cub+1 to=wac.emac.even_b1.cub equation=emac(f1)

fx f1=wac.even.cub+2 to=wac.emac.even_b2.cub equation=emac(f1)

fx f1=wac.even.cub+3 to=wac.emac.even_b3.cub equation=emac(f1)

fx f1=wac.even.cub+4 to=wac.emac.even_b4.cub equation=emac(f1)

fx f1=wac.even.cub+5 to=wac.emac.even_b5.cub equation=emac(f1)

ls -1 wac.emac.even_b*.cub > wac_emac_bands.lis

cubeit fromlist=wac_emac_bands.lis to=wac.emac.even.cubeit.cub

 

Verification

We can verify these outputs are correct by checking if the 1301 fx application output matches the work-around fx output.

We can also verify these outputs are correct by opening these cubes in qview.

cubediff

The fixed 1301 fx ema output cube is identical to the work-around ema output cube.

cubediff from=wac.ema.even.cub from2=wac.ema.even.cubeit.cub

cubediff: Working

100% Processed

Group = Results

  Compare = Identical

End_Group

 

The fixed 1301 fx emac output cube is identical to the work-around emac output cube.

cubediff from=wac.emac.even.cub from2=wac.emac.even.cubeit.cub

cubediff: Working

100% Processed
Group = Results

  Compare = Identical

End_Group

 

qview

Open both wac.even.cub and wac.ema.even.cub. Link both images and use the Find Tool to go to sample, line 100, 100. Then, record the point with

the Advanced Tracking Tool. Use the Band Selection Tool to go to band 2 on each of the images, and record the point. Repeat this for all 5 bands.

When finished, the Advanced Tracking Tool will contain 10 rows, and the Emission Angle should match for each pair of entries (which correspond to

imageX bandN, imageY bandN). 

The emission angles at 100, 100 match for each band for the WAC image and the fx'd EMA image. The table has been saved to

$ISISROOT/../Testing/qview_ema_verification.txt.

"Sample","Line","Emission","FileName"

99.9815,99.9815,23.8015,wac.even.cub

99.9815,99.9815,23.8015,wac.ema.even.cub

99.9815,99.9815,23.0958,wac.even.cub

99.9815,99.9815,23.0958,wac.ema.even.cub

99.9815,99.9815,22.6495,wac.even.cub

99.9815,99.9815,22.6495,wac.ema.even.cub

99.9815,99.9815,22.4371,wac.even.cub

99.9815,99.9815,22.4371,wac.ema.even.cub

99.9815,99.9815,22.467,wac.even.cub

99.9815,99.9815,22.467,wac.ema.even.cub

 

Open both wac.even.cub and wac.emac.even.cub. Link both images and use the Find Tool to go to samle, line 151, 151. These coordinates were

chosen since they are used to calculate the the center angle for this image (as its dimensions are 301, 301). Record the points for each band as

demonstrated above. The Emission Angle should match for each pair of entries.

The center emission angle (151, 151) matches for each band for the WAC image and the fx'd EMAC image. The table has been saved to

$ISISROOT/../Testing/qview_emac_verification.txt.

"Sample","Line","Emission","FileName"

150.802,150.802,19.1756,wac.even.cub

150.802,150.802,19.1756,wac.emac.even.cub

150.802,150.802,18.4369,wac.even.cub

150.802,150.802,18.4369,wac.emac.even.cub

150.802,150.802,17.9965,wac.even.cub

150.802,150.802,17.9965,wac.emac.even.cub

150.802,150.802,17.8475,wac.even.cub

150.802,150.802,17.8475,wac.emac.even.cub

150.802,150.802,17.991,wac.even.cub

150.802,150.802,17.991,wac.emac.even.cub

 

Conclusion

After adding automated tests for a THEMIS-IR image (the [bandDependent] test case for fx) that tests all of the camera operators, and manually

testing an even visible LRO-WAC image with the ema and emac operators for verification purposes, the changes made to fx allow processing

band-dependent images correctly with camera operators.
#34 - 2016-10-13 12:36 PM - Tammy Becker

- Status changed from Resolved to Closed

The testing and documentation on this issue is great.
